Index: branches/1.3/gui/scripts/nanovisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4848)
@@ -1694,75 +1731,85 @@
     #set bfg [option get $itk_component(hull) boldFont Font]
 
+    checkbutton $inner.vol -text "Show volume" -font $fg \
+        -variable [itcl::scope _settings($this-volume)] \
+        -command [itcl::code $this AdjustSetting volume]
     label $inner.shading -text "Shading:" -font $fg
 
     checkbutton $inner.light2side -text "Two-sided lighting" -font $fg \
-        -variable [itcl::scope _settings(-light2side)] \
-        -command [itcl::code $this AdjustSetting -light2side]
-
-    checkbutton $inner.visibility -text "Visible" -font $fg \
-        -variable [itcl::scope _settings(-volumevisible)] \
-        -command [itcl::code $this AdjustSetting -volumevisible]
+        -variable [itcl::scope _settings($this-light2side)] \
+        -command [itcl::code $this AdjustSetting light2side]
 
     label $inner.dim -text "Glow" -font $fg
     ::scale $inner.light -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-light)] \
+        -variable [itcl::scope _settings($this-light)] \
         -width 10 \
-        -showvalue off -command [itcl::code $this AdjustSetting -light]
+        -showvalue off -command [itcl::code $this AdjustSetting light]
     label $inner.bright -text "Surface" -font $fg
 
-    # Opacity
     label $inner.fog -text "Clear" -font $fg
     ::scale $inner.transp -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _widget(-volumeopacity)] \
+        -variable [itcl::scope _settings($this-transp)] \
         -width 10 \
-        -showvalue off -command [itcl::code $this AdjustSetting -volumeopacity]
+        -showvalue off -command [itcl::code $this AdjustSetting transp]
     label $inner.plastic -text "Opaque" -font $fg
 
-    # Tooth thickness
+    label $inner.clear -text "Clear" -font $fg
+    ::scale $inner.opacity -from 0 -to 100 -orient horizontal \
+        -variable [itcl::scope _settings($this-opacity)] \
+        -width 10 \
+        -showvalue off -command [itcl::code $this AdjustSetting opacity]
+    label $inner.opaque -text "Opaque" -font $fg
+
     label $inner.thin -text "Thin" -font $fg
     ::scale $inner.thickness -from 0 -to 1000 -orient horizontal \
-        -variable [itcl::scope _settings(-thickness)] \
+        -variable [itcl::scope _settings($this-thickness)] \
         -width 10 \
-        -showvalue off -command [itcl::code $this AdjustSetting -thickness]
+        -showvalue off -command [itcl::code $this AdjustSetting thickness]
     label $inner.thick -text "Thick" -font $fg
 
-    # Colormap 
-    label $inner.colormap_l -text "Colormap" -font $fg
+    label $inner.colormap_l -text "Colormap" -font "Arial 9" 
     itk_component add colormap {
         Rappture::Combobox $inner.colormap -width 10 -editable no
     }
 
-    $inner.colormap choices insert end [GetColormapList -includeDefault -includeNone]
+    $inner.colormap choices insert end \
+        "BCGYR"              "BCGYR"            \
+        "BGYOR"              "BGYOR"            \
+        "blue"               "blue"             \
+        "blue-to-brown"      "blue-to-brown"    \
+        "blue-to-orange"     "blue-to-orange"   \
+        "blue-to-grey"       "blue-to-grey"     \
+        "green-to-magenta"   "green-to-magenta" \
+        "greyscale"          "greyscale"        \
+        "nanohub"            "nanohub"          \
+        "rainbow"            "rainbow"          \
+        "spectral"           "spectral"         \
+        "ROYGB"              "ROYGB"            \
+        "RYGCB"              "RYGCB"            \
+        "brown-to-blue"      "brown-to-blue"    \
+        "grey-to-blue"       "grey-to-blue"     \
+        "orange-to-blue"     "orange-to-blue"   \
+	"none"		     "none"
+
+    $itk_component(colormap) value "BCGYR"
     bind $inner.colormap <<Value>> \
-        [itcl::code $this AdjustSetting -colormap]
-    $itk_component(colormap) value "default"
-    set _settings(-colormap) "default"
-
-    # Component
-    label $inner.volcomponents_l -text "Component" -font $fg
-    itk_component add volcomponents {
-        Rappture::Combobox $inner.volcomponents -editable no
-    }
-    bind $inner.volcomponents <<Value>> \
-        [itcl::code $this AdjustSetting -current]
+        [itcl::code $this AdjustSetting colormap]
 
     blt::table $inner \
-        0,0 $inner.volcomponents_l -anchor e -cspan 2 \
-        0,2 $inner.volcomponents             -cspan 3 -fill x \
+        0,0 $inner.vol -cspan 4 -anchor w -pady 2 \
         1,0 $inner.shading -cspan 4 -anchor w -pady {10 2} \
         2,0 $inner.light2side -cspan 4 -anchor w -pady 2 \
-        3,0 $inner.visibility -cspan 4 -anchor w -pady 2 \
-        4,0 $inner.dim -anchor e -pady 2 \
-        4,1 $inner.light -cspan 2 -pady 2 -fill x \
-        4,3 $inner.bright -anchor w -pady 2 \
-        5,0 $inner.fog -anchor e -pady 2 \
-        5,1 $inner.transp -cspan 2 -pady 2 -fill x \
-        5,3 $inner.plastic -anchor w -pady 2 \
-        6,0 $inner.thin -anchor e -pady 2 \
-        6,1 $inner.thickness -cspan 2 -pady 2 -fill x\
-        6,3 $inner.thick -anchor w -pady 2
+        3,0 $inner.dim -anchor e -pady 2 \
+        3,1 $inner.light -cspan 2 -pady 2 -fill x \
+        3,3 $inner.bright -anchor w -pady 2 \
+        4,0 $inner.fog -anchor e -pady 2 \
+        4,1 $inner.transp -cspan 2 -pady 2 -fill x \
+        4,3 $inner.plastic -anchor w -pady 2 \
+        5,0 $inner.thin -anchor e -pady 2 \
+        5,1 $inner.thickness -cspan 2 -pady 2 -fill x\
+        5,3 $inner.thick -anchor w -pady 2
 
     blt::table configure $inner c0 c1 c3 r* -resize none
-    blt::table configure $inner r7 -resize expand
+    blt::table configure $inner r6 -resize expand
 }
 
@@ -1773,10 +1820,4 @@
     $inner configure -borderwidth 4
 
-    checkbutton $inner.visible \
-        -text "Show Cutplanes" \
-        -variable [itcl::scope _settings(-cutplanesvisible)] \
-        -command [itcl::code $this AdjustSetting -cutplanesvisible] \
-        -font "Arial 9"
-
     # X-value slicer...
     itk_component add xCutButton {
@@ -1784,10 +1825,9 @@
             -onimage [Rappture::icon x-cutplane] \
             -offimage [Rappture::icon x-cutplane] \
-            -command [itcl::code $this AdjustSetting -xcutplanevisible] \
-            -variable [itcl::scope _settings(-xcutplanevisible)]
+            -command [itcl::code $this AdjustSetting xcutplane] \
+            -variable [itcl::scope _settings($this-xcutplane)]
     }
     Rappture::Tooltip::for $itk_component(xCutButton) \
         "Toggle the X cut plane on/off"
-    $itk_component(xCutButton) select
 
     itk_component add xCutScale {
@@ -1796,5 +1836,5 @@
             -borderwidth 1 -highlightthickness 0 \
             -command [itcl::code $this Slice move x] \
-            -variable [itcl::scope _settings(-xcutplaneposition)]
+            -variable [itcl::scope _settings($this-xcutposition)]
     } {
         usual
@@ -1812,10 +1852,9 @@
             -onimage [Rappture::icon y-cutplane] \
             -offimage [Rappture::icon y-cutplane] \
-            -command [itcl::code $this AdjustSetting -ycutplanevisible] \
-            -variable [itcl::scope _settings(-ycutplanevisible)]
+            -command [itcl::code $this AdjustSetting ycutplane] \
+            -variable [itcl::scope _settings($this-ycutplane)]
     }
     Rappture::Tooltip::for $itk_component(yCutButton) \
         "Toggle the Y cut plane on/off"
-    $itk_component(yCutButton) select
 
     itk_component add yCutScale {
@@ -1824,5 +1863,5 @@
             -borderwidth 1 -highlightthickness 0 \
             -command [itcl::code $this Slice move y] \
-            -variable [itcl::scope _settings(-ycutplaneposition)]
+            -variable [itcl::scope _settings($this-ycutposition)]
     } {
         usual
@@ -1840,10 +1879,9 @@
             -onimage [Rappture::icon z-cutplane] \
             -offimage [Rappture::icon z-cutplane] \
-            -command [itcl::code $this AdjustSetting -zcutplanevisible] \
-            -variable [itcl::scope _settings(-zcutplanevisible)]
+            -command [itcl::code $this AdjustSetting zcutplane] \
+            -variable [itcl::scope _settings($this-zcutplane)]
     }
     Rappture::Tooltip::for $itk_component(zCutButton) \
         "Toggle the Z cut plane on/off"
-    $itk_component(zCutButton) select
 
     itk_component add zCutScale {
@@ -1852,5 +1890,5 @@
             -borderwidth 1 -highlightthickness 0 \
             -command [itcl::code $this Slice move z] \
-            -variable [itcl::scope _settings(-zcutplaneposition)]
+            -variable [itcl::scope _settings($this-zcutposition)]
     } {
         usual
@@ -1859,18 +1897,18 @@
     $itk_component(zCutScale) set 50
     $itk_component(zCutScale) configure -state disabled
+    #$itk_component(zCutScale) configure -state disabled
     Rappture::Tooltip::for $itk_component(zCutScale) \
         "@[itcl::code $this SlicerTip z]"
 
     blt::table $inner \
-        0,1 $inner.visible              -anchor w -pady 2 -cspan 4 \
-        1,1 $itk_component(xCutScale) \
-        1,2 $itk_component(yCutScale) \
-        1,3 $itk_component(zCutScale) \
-        2,1 $itk_component(xCutButton) \
-        2,2 $itk_component(yCutButton) \
-        2,3 $itk_component(zCutButton)
-
-    blt::table configure $inner r0 r1 r2 c* -resize none
-    blt::table configure $inner r3 c4 -resize expand
+        1,1 $itk_component(xCutButton) \
+        1,2 $itk_component(yCutButton) \
+        1,3 $itk_component(zCutButton) \
+        0,1 $itk_component(xCutScale) \
+        0,2 $itk_component(yCutScale) \
+        0,3 $itk_component(zCutScale) 
+
+    blt::table configure $inner r0 r1 c* -resize none
+    blt::table configure $inner r2 c4 -resize expand
     blt::table configure $inner c0 -width 2
     blt::table configure $inner c1 c2 c3 -padx 2
@@ -1895,5 +1933,4 @@
         0,0 $inner.view_l -anchor e -pady 2 \
         0,1 $inner.view -anchor w -pady 2
-    blt::table configure $inner r0 -resize none
 
     set row 1
@@ -1902,9 +1939,9 @@
         label $inner.${tag}label -text $tag -font "Arial 9"
         entry $inner.${tag} -font "Arial 9"  -bg white \
-            -textvariable [itcl::scope _settings(-$tag)]
+            -textvariable [itcl::scope _settings($this-$tag)]
         bind $inner.${tag} <Return> \
-            [itcl::code $this camera set -${tag}]
+            [itcl::code $this camera set ${tag}]
         bind $inner.${tag} <KP_Enter> \
-            [itcl::code $this camera set -${tag}]
+            [itcl::code $this camera set ${tag}]
         blt::table $inner \
             $row,0 $inner.${tag}label -anchor e -pady 2 \
@@ -1914,5 +1951,5 @@
     }
 
-    blt::table configure $inner c* -resize none
+    blt::table configure $inner c* r* -resize none
     blt::table configure $inner c2 -resize expand
     blt::table configure $inner r$row -resize expand
@@ -1955,4 +1992,7 @@
 itcl::body Rappture::NanovisViewer::SlicerTip {axis} {
     set val [$itk_component(${axis}CutScale) get]
+#    set val [expr {0.01*($val-50)
+#        *($_limits(${axis}max)-$_limits(${axis}min))
+#          + 0.5*($_limits(${axis}max)+$_limits(${axis}min))}]
     return "Move the [string toupper $axis] cut plane.\nCurrently:  $axis = $val%"
 }
@@ -1975,5 +2015,5 @@
 }
 
-itcl::body Rappture::NanovisViewer::EventuallyRedrawLegend {} {
+itcl::body Rappture::NanovisViewer::EventuallyResizeLegend {} {
     if { !$_resizeLegendPending } {
         $_dispatcher event -idle !legend
@@ -1990,25 +2030,25 @@
         }
         "set" {
-            set what [lindex $args 0]
-            set x $_settings($what)
+            set who [lindex $args 0]
+            set x $_settings($this-$who)
             set code [catch { string is double $x } result]
             if { $code != 0 || !$result } {
-                set _settings($what) $_view($what)
+                set _settings($this-$who) $_view($who)
                 return
             }
-            switch -- $what {
-                "-xpan" - "-ypan" {
-                    set _view($what) $_settings($what)
+            switch -- $who {
+                "xpan" - "ypan" {
+                    set _view($who) $_settings($this-$who)
                     PanCamera
                 }
-                "-qx" - "-qy" - "-qz" - "-qw" {
-                    set _view($what) $_settings($what)
-                    set q [ViewToQuaternion]
+                "qx" - "qy" - "qz" - "qw" {
+                    set _view($who) $_settings($this-$who)
+                    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
                     $_arcball quaternion $q
                     SendCmd "camera orient $q"
                 }
-                "-zoom" {
-                    set _view($what) $_settings($what)
-                    SendCmd "camera zoom $_view($what)"
+                "zoom" {
+                    set _view($who) $_settings($this-$who)
+                    SendCmd "camera zoom $_view(zoom)"
                 }
             }
@@ -2050,15 +2090,15 @@
         array set info $vol
         set name $info(name)
-        if { ![info exists _settings(-volumevisible-$name)] } {
-            set _settings(-volumevisible-$name) $info(hide)
+        if { ![info exists _settings($this-volume-$name)] } {
+            set _settings($this-volume-$name) $info(hide)
         }
         checkbutton $inner.vol$row -text $info(label) \
-            -variable [itcl::scope _settings(-volumevisible-$name)] \
+            -variable [itcl::scope _settings($this-volume-$name)] \
             -onvalue 0 -offvalue 1 \
-            -command [itcl::code $this ToggleVolume $key $name] \
+            -command [itcl::code $this volume $key $name] \
             -font "Arial 9"
         Rappture::Tooltip::for $inner.vol$row $info(description)
         blt::table $inner $row,0 $inner.vol$row -anchor w 
-        if { !$_settings(-volume-$name) } {
+        if { !$_settings($this-volume-$name) } {
             $inner.vol$row select
         } 
@@ -2071,7 +2111,7 @@
 }
 
-itcl::body Rappture::NanovisViewer::ToggleVolume { tag name } {
-    set bool $_settings(-volumevisible-$name)
-    SendCmd "volume state $bool $name"
+itcl::body Rappture::NanovisViewer::volume { tag name } {
+    set bool $_settings($this-volume-$name)
+    SendCmd "volume statue $bool $name"
 }
 
@@ -2085,402 +2125,17 @@
         bottom "0.707107 0.707107 0 0"
     }
-    foreach name { -qw -qx -qy -qz } value $positions($side) {
+    foreach name { qw qx qy qz } value $positions($side) {
         set _view($name) $value
     } 
-    set q [ViewToQuaternion]
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
     $_arcball quaternion $q
     SendCmd "camera orient $q" 
     SendCmd "camera reset"
-    set _view(-xpan) 0
-    set _view(-ypan) 0
-    set _view(-zoom) 1.0
-    set _settings(-xpan) $_view(-xpan)
-    set _settings(-ypan) $_view(-ypan)
-    set _settings(-zoom) $_view(-zoom)
-}
-
-
-#
-# InitComponentSettings --
-#
-#    Initializes the volume settings for a specific component. This should
-#    match what's used as global settings above. This is called the first
-#    time we try to switch to a given component in SwitchComponent below.
-#
-itcl::body Rappture::NanovisViewer::InitComponentSettings { cname } { 
-    foreach {key value} {
-        -colormap          "default"
-        -light             40
-        -light2side        1
-        -thickness         350
-        -volumeopacity     1.0
-        -volumevisible     1
-    } {
-        if { ![info exists _settings($cname${key})] } {
-            # Don't override existing component settings
-            set _settings($cname${key}) $value
-        }
-    }
-}
-
-#
-# SwitchComponent --
-#
-#    This is called when the current component is changed by the dropdown
-#    menu in the volume tab.  It synchronizes the global volume settings
-#    with the settings of the new current component.
-#
-itcl::body Rappture::NanovisViewer::SwitchComponent { cname } { 
-    if { ![info exists _settings($cname-light)] } {
-        InitComponentSettings $cname
-    }
-    if { $_settings(-colormap) != $_settings($cname-colormap) } {
-        set _settings(-colormap)         $_settings($cname-colormap)
-        EventuallyRedrawLegend
-    }
-    # _settings variables change widgets, except for colormap
-    set _settings(-light)            $_settings($cname-light)
-    set _settings(-light2side)       $_settings($cname-light2side)
-    set _settings(-volumeopacity)    $_settings($cname-volumeopacity)
-    set _settings(-thickness)        $_settings($cname-thickness)
-    set _settings(-volumevisible)    $_settings($cname-volumevisible)
-    $itk_component(colormap) value   $_settings($cname-colormap)
-
-    set _widget(-volumeopacity) [expr $_settings(-volumeopacity) * 100.0]
-
-    set _current $cname;                # Reset the current component
-}
-
-#
-# BuildVolumeComponents --
-#
-#    This is called from the "scale" method which is called when a new
-#    dataset is added or deleted.  It repopulates the dropdown menu of
-#    volume component names.  It sets the current component to the first
-#    component in the list (of components found).  Finally, if there is
-#    only one component, don't display the label or the combobox in the
-#    volume settings tab.
-#
-itcl::body Rappture::NanovisViewer::BuildVolumeComponents {} { 
-    $itk_component(volcomponents) choices delete 0 end
-    foreach name $_componentsList {
-        $itk_component(volcomponents) choices insert end $name $name
-    }
-    set _current [lindex $_componentsList 0]
-    $itk_component(volcomponents) value $_current
-    set parent [winfo parent $itk_component(volcomponents)]
-    if { [llength $_componentsList] <= 1 } {
-        # Unpack the components label and dropdown if there's only one
-        # component. 
-        blt::table forget $parent.volcomponents_l $parent.volcomponents
-    } else {
-        # Pack the components label and dropdown into the table there's 
-        # more than one component to select. 
-        blt::table $parent \
-            0,0 $parent.volcomponents_l -anchor e -cspan 2 \
-            0,2 $parent.volcomponents -cspan 3 -fill x 
-    }
-}
-
-#
-# GetDatasetsWithComponents --
-#
-#    Returns a list of all the datasets (known by the combination of their
-#    data object and component name) that match the given component name.
-#    For example, this is used where we want to change the settings of
-#    volumes that have the current component.
-#
-itcl::body Rappture::NanovisViewer::GetDatasetsWithComponent { cname } { 
-    if { ![info exists _volcomponents($cname)] } {
-        return ""
-    }
-    set list ""
-    foreach tag $_volcomponents($cname) {
-        if { ![info exists _serverDatasets($tag)] } {
-            continue
-        }
-        lappend list $tag
-    }
-    return $list
-}
-
-#
-# HideAllMarkers --
-#
-#    Hide all the markers in all the transfer functions.  Can't simply
-#    delete and recreate markers from the <style> since the user may have
-#    created, deleted, or moved markers.
-#
-itcl::body Rappture::NanovisViewer::HideAllMarkers {} { 
-    foreach cname [array names _transferFunctionEditors] {
-        $_transferFunctionEditors($cname) hideMarkers 
-    }
-}
-
-itcl::body Rappture::NanovisViewer::GetColormap { cname color } { 
-    if { $color == "default" } {
-        return $_cname2defaultcolormap($cname)
-    }
-    return [ColorsToColormap $color]
-}
-
-itcl::body Rappture::NanovisViewer::GetAlphamap { cname name } { 
-    if { $name == "default" } {
-        return $_cname2defaultalphamap($cname)
-    }
-    return [NameToAlphamap $name]
-}
-
-itcl::body Rappture::NanovisViewer::ResetColormap { cname color } { 
-    # Get the current transfer function
-    if { ![info exists _cname2transferFunction($cname)] } {
-        return
-    }
-    foreach { cmap wmap } $_cname2transferFunction($cname) break
-    set cmap [GetColormap $cname $color]
-    set _cname2transferFunction($cname) [list $cmap $wmap]
-    SendCmd [list transfunc define $cname $cmap $wmap]
-    EventuallyRedrawLegend
-}
-
-itcl::body Rappture::NanovisViewer::ComputeAlphamap { cname } { 
-    if { ![info exists _transferFunctionEditors($cname)] } {
-        return [list 0.0 0.0 1.0 1.0]
-    }
-    if { ![info exists _settings($cname-light)] } {
-        InitComponentSettings $cname
-    }
-
-    set isovalues [$_transferFunctionEditors($cname) values]
-
-    # Transfer function should be normalized with [0,1] range
-    # The volume shading opacity setting is used to scale opacity
-    # in the volume shader.
-    set max 1.0
-
-    # Use the component-wise thickness setting from the slider
-    # settings widget
-    # Scale values between 0.00001 and 0.01000
-    set delta [expr {double($_settings($cname-thickness)) * 0.0001}]
-    
-    set first [lindex $isovalues 0]
-    set last [lindex $isovalues end]
-    set wmap ""
-    if { $first == "" || $first != 0.0 } {
-        lappend wmap 0.0 0.0
-    }
-    foreach x $isovalues {
-        set x1 [expr {$x-$delta-0.00001}]
-        set x2 [expr {$x-$delta}]
-        set x3 [expr {$x+$delta}]
-        set x4 [expr {$x+$delta+0.00001}]
-        if { $x1 < 0.0 } {
-            set x1 0.0
-        } elseif { $x1 > 1.0 } {
-            set x1 1.0
-        }
-        if { $x2 < 0.0 } {
-            set x2 0.0
-        } elseif { $x2 > 1.0 } {
-            set x2 1.0
-        }
-        if { $x3 < 0.0 } {
-            set x3 0.0
-        } elseif { $x3 > 1.0 } {
-            set x3 1.0
-        }
-        if { $x4 < 0.0 } {
-            set x4 0.0
-        } elseif { $x4 > 1.0 } {
-            set x4 1.0
-        }
-        # add spikes in the middle
-        lappend wmap $x1 0.0
-        lappend wmap $x2 $max
-        lappend wmap $x3 $max
-        lappend wmap $x4 0.0
-    }
-    if { $last == "" || $last != 1.0 } {
-        lappend wmap 1.0 0.0
-    }
-    return $wmap
-}
-
-itcl::body Rappture::NanovisViewer::NameToAlphamap { name } {
-    switch -- $name {
-        "ramp-up" {
-            set wmap { 
-                0.0 0.0 
-                1.0 1.0 
-            }
-        }
-        "ramp-down" {
-            set wmap { 
-                0.0 1.0 
-                1.0 0.0 
-            }
-        }
-        "vee" {
-            set wmap { 
-                0.0 1.0 
-                0.5 0.0 
-                1.0 1.0 
-            }
-        }
-        "tent-1" {
-            set wmap { 
-                0.0 0.0 
-                0.5 1.0 
-                1.0 0.0 
-            }
-        }
-        "tent-2" {
-            set wmap { 
-                0.0 0.0 
-                0.25 1.0 
-                0.5 0.0 
-                0.75 1.0 
-                1.0 0.0 
-            }
-        }
-        "tent-3" {
-            set wmap { 
-                0.0 0.0 
-                0.16666 1.0
-                0.33333 0.0
-                0.5     1.0
-                0.66666 0.0
-                0.83333 1.0
-                1.0 0.0 
-            }
-        }
-        "tent-4" {
-            set wmap { 
-                0.0     0.0 
-                0.125   1.0
-                0.25    0.0
-                0.375   1.0
-                0.5     0.0        
-                0.625   1.0
-                0.75    0.0
-                0.875   1.0
-                1.0     0.0 
-            }
-        }
-        "sinusoid-1" {
-            set wmap {
-                0.0                     0.000 0.600 0.800 
-                0.14285714285714285     0.400 0.900 1.000 
-                0.2857142857142857      0.600 1.000 1.000 
-                0.42857142857142855     0.800 1.000 1.000 
-                0.5714285714285714      0.900 0.900 0.900 
-                0.7142857142857143      0.600 0.600 0.600 
-                0.8571428571428571      0.400 0.400 0.400 
-                1.0                     0.200 0.200 0.200
-            }
-        }
-        "sinusoid-2" {
-            set wmap { 
-                0.0                     0.900 1.000 1.000 
-                0.1111111111111111      0.800 0.983 1.000 
-                0.2222222222222222      0.700 0.950 1.000 
-                0.3333333333333333      0.600 0.900 1.000 
-                0.4444444444444444      0.500 0.833 1.000 
-                0.5555555555555556      0.400 0.750 1.000 
-                0.6666666666666666      0.300 0.650 1.000 
-                0.7777777777777778      0.200 0.533 1.000 
-                0.8888888888888888      0.100 0.400 1.000 
-                1.0                     0.000 0.250 1.000
-            }
-        }
-        "sinusoid-6" {
-            set wmap {
-                0.0                             0.200   0.100   0.000 
-                0.09090909090909091             0.400   0.187   0.000 
-                0.18181818181818182             0.600   0.379   0.210 
-                0.2727272727272727              0.800   0.608   0.480 
-                0.36363636363636365             0.850   0.688   0.595 
-                0.45454545454545453             0.950   0.855   0.808 
-                0.5454545454545454              0.800   0.993   1.000 
-                0.6363636363636364              0.600   0.973   1.000 
-                0.7272727272727273              0.400   0.940   1.000 
-                0.8181818181818182              0.200   0.893   1.000 
-                0.9090909090909091              0.000   0.667   0.800 
-                1.0                             0.000   0.480   0.600 
-            }
-        }
-        "sinusoid-10" {
-            set wmap {
-                0.0                             0.000   0.480   0.600 
-                0.09090909090909091             0.000   0.667   0.800 
-                0.18181818181818182             0.200   0.893   1.000 
-                0.2727272727272727              0.400   0.940   1.000 
-                0.36363636363636365             0.600   0.973   1.000 
-                0.45454545454545453             0.800   0.993   1.000 
-                0.5454545454545454              0.950   0.855   0.808 
-                0.6363636363636364              0.850   0.688   0.595 
-                0.7272727272727273              0.800   0.608   0.480 
-                0.8181818181818182              0.600   0.379   0.210 
-                0.9090909090909091              0.400   0.187   0.000 
-                1.0                             0.200   0.100   0.000 
-            }
-        }
-        "step-2" {
-            set wmap {
-                0.0                             0.000   0.167   1.000
-                0.09090909090909091             0.100   0.400   1.000
-                0.18181818181818182             0.200   0.600   1.000
-                0.2727272727272727              0.400   0.800   1.000
-                0.36363636363636365             0.600   0.933   1.000
-                0.45454545454545453             0.800   1.000   1.000
-                0.5454545454545454              1.000   1.000   0.800
-                0.6363636363636364              1.000   0.933   0.600
-                0.7272727272727273              1.000   0.800   0.400
-                0.8181818181818182              1.000   0.600   0.200
-                0.9090909090909091              1.000   0.400   0.100
-                1.0                             1.000   0.167   0.000
-            }
-        }
-        "step-5" {
-            set wmap {
-                0.0                             1.000   0.167   0.000
-                0.09090909090909091             1.000   0.400   0.100
-                0.18181818181818182             1.000   0.600   0.200
-                0.2727272727272727              1.000   0.800   0.400
-                0.36363636363636365             1.000   0.933   0.600
-                0.45454545454545453             1.000   1.000   0.800
-                0.5454545454545454              0.800   1.000   1.000
-                0.6363636363636364              0.600   0.933   1.000
-                0.7272727272727273              0.400   0.800   1.000
-                0.8181818181818182              0.200   0.600   1.000
-                0.9090909090909091              0.100   0.400   1.000
-                1.0                             0.000   0.167   1.000
-            }
-        }
-        "step-12" {
-            set wmap {
-                "#EE82EE"
-                "#4B0082" 
-                "blue" 
-                "#008000" 
-                "yellow" 
-                "#FFA500" 
-                "red" 
-            }
-        }
-        default {
-        }
-    }
-    return ""
-}
-
-itcl::body Rappture::NanovisViewer::SetObjectStyle { dataobj cname } {
-    array set styles {
-        -opacity  0.5
-    }
-    array set styles [lindex [$dataobj components -style $cname] 0]
-    set _settings($cname-volumeopacity) $styles(-opacity)
-    set tag $dataobj-$cname
-    SendCmd "volume shading opacity $_settings($cname-volumeopacity) $tag"
-    NameTransferFunction $dataobj $cname
-}
+    set _view(xpan) 0
+    set _view(ypan) 0
+    set _view(zoom) 1.0
+    set _settings($this-xpan) $_view(xpan)
+    set _settings($this-ypan) $_view(ypan)
+    set _settings($this-zoom) $_view(zoom)
+}
+
